﻿Type=Activity
Version=2.22
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim hc2 As HttpClient
	Dim FRIENDS_LIST As Int
	FRIENDS_LIST = 1
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim MapView1 As MapView
    Dim MarkersOverlay1 As MarkersOverlay
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	If FirstTime Then
		hc2.Initialize("hc2")
	End If	
 	If File.ExternalWritable=False Then
        '    OSMDroid requires the use of external storage to cache tiles
        '    if no external storage is available then the MapView will display no tiles
        Log("WARNING NO EXTERNAL STORAGE AVAILABLE")
    End If
    
    '    no EventName is required as we don't need to listen for MapView events
    MapView1.Initialize("")
    Activity.AddView(MapView1, 0, 0, 100%x, 100%y)
    
    '    by default the map will zoom in on a double tap and also be draggable - no other user interface features are enabled
    
    '    enable the built in zoom controller - the map can now be zoomed in and out
    MapView1.SetZoomEnabled(True)
    
    '    enable the built in multi touch controller - the map can now be 'pinch zoomed'
    MapView1.SetMultiTouchEnabled(True)
    
    '    set the zoom level BEFORE the center (otherwise unpredictable map center may be set)
    MapView1.Zoom=14
 '   MapView1.SetCenter(Main.Lat, Main.Lon)
	MapView1.SetCenter(41.02581277024001,16.99536102823913)
'	MapView1.SetTileSource("MapquestAerial")
	MarkersOverlay1.Initialize(MapView1, "MarkersOverlay1")
    MapView1.AddOverlay(MarkersOverlay1)
	FetchFriendsList
End Sub

Sub Activity_Resume
	FetchFriendsList
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub FetchFriendsList
	ProgressDialogShow("Ricerca Utenti in Corso")
	'Gets all the available countries
	ExecuteRemoteQuery("SELECT * FROM markers", FRIENDS_LIST)
End Sub

Sub ExecuteRemoteQuery(Query As String, TaskId As Int)
	Dim req As HttpRequest
	req.InitializePost2("http://www.emmecisistemi.com/estasi_query.php", Query.GetBytes("UTF8"))
	hc2.Execute(req, TaskId)
End Sub

Sub hc2_ResponseError (Response As HttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	Log("Error: " & Reason & ", StatusCode: " & StatusCode)
	If Response <> Null Then
		Log(Response.GetString("UTF8"))
		Response.Release
	End If
	ProgressDialogHide
End Sub

Sub hc2_ResponseSuccess (Response As HttpResponse, TaskId As Int)
	Dim res As String
	res = Response.GetString("UTF8")
	Log("Response from server: " & res)
	Dim parser As JSONParser
	parser.Initialize(res)
	Dim Icon As BitmapDrawable
    Icon.Initialize(LoadBitmap(File.DirAssets, "person.png"))
	Select TaskId
		Case FRIENDS_LIST
			'add the countries to the ListView
			Dim nearfriends As List
			nearfriends = parser.NextArray 'returns a list with maps
			Dim recno As Int
			recno = nearfriends.Size
			Dim AnArray(recno) As Object
			For i = 0 To nearfriends.Size - 1
				Dim m As Map
				Dim Marker1 As Marker
				m = nearfriends.Get(i)
				'markers
				Marker1.Initialize(m.Get("name"),m.Get("address"), m.Get("lat"),m.Get("lng"), Icon)
				AnArray(i)=Marker1
			Next
		    ' create a List and initialize it with the Markers
		    Dim Markers As List
		    Markers.Initialize2(Array As Object(AnArray))        
		    ' add the List of Markers to the MarkersOverlay
   			MarkersOverlay1.AddMarkers(Markers)
			ProgressDialogHide
		End Select
	Response.Release
End Sub